/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.3 Standard
Automatic Program Generator
 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project :
Version :
Date    : 12.02.2015
Author  : PerTic@n
Company : If You Like This Software,Buy It
Comments:


Chip type               : ATtiny13
AVR Core Clock frequency: 4.800000 MHz
Memory model            : Tiny
External RAM size       : 0
Data Stack size         : 16
*****************************************************/

#include <tiny13.h>
#include <delay.h>

//     
         //---------0------1----2------3-----4-----5----6-----7-----8-----9------FF
char SEGMENTE[] = {0x04, 0x3E, 0x48, 0x18, 0x32, 0x11, 0x01, 0x3C, 0x00, 0x10, 0xFF, 0xFB};
volatile unsigned char a,imp,limp;
//     
void write_display(unsigned char *data, unsigned char nbytes)
{
    unsigned char mask,i,k;
    for(i = 0; i < nbytes; i++)
    {
    mask = 0x80;
    for(k = 0; k < 8; k++)
    {
//     
    if(data[i] & mask)
    {
    PORTB.0=1; // |= (1 << PB0); // DATA 1
    PORTB.2=1;// |= (1 << PB2); // CLK 1
    PORTB.2=0;// &= ~(1 << PB2); // CLK 0
    }
    else
    {
    PORTB.0=0; // &= ~(1 << PB0); // DATA 0
    PORTB.2=1; // |= (1 << PB2); // CLK 1
    PORTB.2=0;// &= ~(1 << PB2); // CLK 0
    }
    mask = mask >> 1; //  
    }
  }
//  
PORTB.3=1;  // |= (1 << PB1);
PORTB.3=0; // &= ~(1 << PB1);
}

unsigned char display[2];
// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
imp=imp+1;
}

// Timer 0 overflow interrupt service routine
void main(void)
{
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
// Input/Output Ports initialization
// Port B initialization
PORTB=0x00;
DDRB=0x3D;

 // External Interrupt(s) initialization
GIMSK=0x40; // INT0: On
MCUCR=0x03; // INT0 Mode: Rising Edge
GIFR=0x40;  // Interrupt on any change on pins PCINT0-5: Off

 display[0] =  SEGMENTE[11];
 display[1] =  SEGMENTE[11];
 write_display(display,2);

// Global enable interrupts
#asm("sei")
while (1)
      {
            delay_ms(8);
            if((imp>0) && (imp==limp))
            {imp=0;
            display[0] =  SEGMENTE[limp%10];
            if (limp<10) 
            {
             a=10;
            }
            else  
            {
             a=limp/10;   
            };
            display[1] =  SEGMENTE[a];
            write_display(display,2);
             }
             limp=imp;
           
      }
      
      

}
